Index: trunk/language/fr_FR.iso-8859-1/common.lang.php
===================================================================
--- trunk/language/fr_FR.iso-8859-1/common.lang.php	(revision 1118)
+++ trunk/language/fr_FR.iso-8859-1/common.lang.php	(revision 1119)
@@ -40,6 +40,11 @@
 $lang['%d new elements'] = '%d nouveaux éléments';
 $lang['%d new users'] = '%d nouveaux utilisateurs';
+$lang['%d pictures are also linked to current tags'] = '%d images sont également liées aux tags courants';
 $lang['About'] = 'À propos';
+$lang['All tags must match'] = 'Tous les tags doivent correspondre';
+$lang['All tags'] = 'Tous les tags';
+$lang['Any tag'] = 'N\'importe quel tag';
 $lang['At least one listed rule must be satisfied.'] = 'Au moins un des critères doit être satisfait.';
+$lang['At least one tag must match'] = 'Au moins un tag doit correspondre';
 $lang['Author'] = 'Auteur';
 $lang['Average rate'] = 'Note moyenne';
@@ -62,6 +67,6 @@
 $lang['Enter your personnal informations'] = 'Entrer vos informations personnelles';
 $lang['Error sending email'] = 'Erreur à l\'envoi du mail';
+$lang['File name'] = 'Nom du fichier';
 $lang['File'] = 'Fichier';
-$lang['File name'] = 'Nom du fichier';
 $lang['Filesize'] = 'Poids';
 $lang['Filter and display'] = 'Filtrer et afficher';
@@ -91,19 +96,24 @@
 $lang['Profile'] = 'Profil';
 $lang['Quick connect'] = 'Connexion rapide';
+$lang['RSS feed'] = 'flux RSS';
 $lang['Rate'] = 'Note';
-$lang['RSS feed'] = 'flux RSS';
 $lang['Register'] = 'S\'enregistrer';
 $lang['Registration'] = 'Enregistrement';
+$lang['Related tags'] = 'Tags liés';
 $lang['Reset'] = 'Annuler';
 $lang['Retrieve password'] = 'Récupérer un mot de passe';
 $lang['Search rules'] = 'Critères de recherche';
+$lang['Search tags'] = 'Rechercher les tags';
 $lang['Search'] = 'Rechercher';
+$lang['See available tags'] = 'Voir les tags disponibles';
+$lang['See pictures linked to this tag only'] = 'Voir les images liées uniquement à ce tag';
 $lang['Send new password'] = 'Envoyer le nouveau mot de passe';
 $lang['Since'] = 'Depuis';
 $lang['Sort by'] = 'Trier selon';
 $lang['Sort order'] = 'Ordre de tri';
+$lang['Tag'] = 'Tag';
+$lang['Tags'] = 'Tags';
 $lang['The RSS notification feed provides notification on news from this website : new pictures, updated categories, new comments. Use a RSS feed reader.'] = 'Le flux RSS notifie les événements de la galerie : nouvelles images, catégories mises à jour, nouveaux commentaires utilisateur. À utiliser avec un lecteur de flux RSS.';
 $lang['Unknown feed identifier'] = 'Identifiant de flux inconnu';
-$lang['nbm_unknown_identifier'] = 'Identifiants inconnus';
 $lang['User comments'] = 'Commentaires utilisateur';
 $lang['Username'] = 'Nom d\'utilisateur';
@@ -117,4 +127,5 @@
 $lang['add_favorites_hint'] = 'Ajouter cette image à vos favoris';
 $lang['admin'] = 'Administration';
+$lang['adviser_mode_enabled'] = 'Mode conseiller actif';
 $lang['all'] = 'tout';
 $lang['all_categories'] = 'toutes les catégories';
@@ -135,6 +146,6 @@
 $lang['calendar_picture_hint'] = 'afficher les images du ';
 $lang['calendar_view'] = 'Vue';
+$lang['chronology_monthly_calendar'] = 'Calendrier mensuel';
 $lang['chronology_monthly_list'] = 'Liste mensuelle';
-$lang['chronology_monthly_calendar'] = 'Calendrier mensuel';
 $lang['chronology_weekly_list'] = 'Liste hebdomadaire';
 $lang['click_to_redirect'] = 'Cliquez ici si votre navigateur ne vous redirige pas.';
@@ -211,6 +222,6 @@
 $lang['maxwidth'] = 'Largeur maximum des images';
 $lang['maxwidth_error'] = 'La largeur des images doit être supérieure à 50';
+$lang['mode_created_hint'] = 'afficher un calendrier par date de création';
 $lang['mode_normal_hint'] = 'retourne à la vue normale';
-$lang['mode_created_hint'] = 'afficher un calendrier par date de création';
 $lang['mode_posted_hint'] = 'afficher un calendrier par date d\'ajout';
 $lang['month'][10] = 'Octobre';
@@ -228,8 +239,9 @@
 $lang['most_visited_cat'] = 'Plus vues';
 $lang['most_visited_cat_hint'] = 'afficher les images les plus vues';
+$lang['nb_image_line_error'] = 'Le nombre d\'images par ligne doit être un entier non nul';
 $lang['nb_image_per_row'] = 'Nombre de miniatures par ligne';
-$lang['nb_image_line_error'] = 'Le nombre d\'images par ligne doit être un entier non nul';
+$lang['nb_line_page_error'] = 'Le nombre de lignes par page doit être un entier non nul';
 $lang['nb_row_per_page'] = 'Nombre de lignes par page';
-$lang['nb_line_page_error'] = 'Le nombre de lignes par page doit être un entier non nul';
+$lang['nbm_unknown_identifier'] = 'Identifiants inconnus';
 $lang['never_rated'] = 'Vous n\'avez jamais voté pour cette image';
 $lang['new_password'] = 'Nouveau mot de passe';
@@ -333,4 +345,3 @@
 $lang['w_month'] = 'Mois';
 $lang['yes'] = 'Oui';
-$lang['adviser_mode_enabled'] = 'Mode conseiller actif';
 ?>
Index: trunk/picture.php
===================================================================
--- trunk/picture.php	(revision 1118)
+++ trunk/picture.php	(revision 1119)
@@ -699,23 +699,41 @@
 $infos['INFO_FILE'] = $picture['current']['file'];
 
-// keywords
-if (!empty($picture['current']['keywords']))
-{
-  $infos['INFO_KEYWORDS'] =
-    // FIXME because of search engine partial rewrite, giving the author
-    // name threw GET is not supported anymore. This feature should come
-    // back later, with a better design (tag classification).
-//     preg_replace(
-//       '/([^,]+)/',
-//       '<a href="'.
-//         PHPWG_ROOT_PATH.'category.php?cat=search&amp;search=keywords:$1'
-//         .'">$1</a>',
-//       $picture['current']['keywords']
-//       );
-    $picture['current']['keywords'];
+// tags
+$query = '
+SELECT id, name, url_name
+  FROM '.IMAGE_TAG_TABLE.'
+    INNER JOIN '.TAGS_TABLE.' ON tag_id = id
+  WHERE image_id = '.$page['image_id'].'
+;';
+$result = pwg_query($query);
+
+if (mysql_num_rows($result) > 0)
+{
+  $tags = array();
+  
+  while ($row = mysql_fetch_array($result))
+  {
+    array_push(
+      $tags,
+      '<a href="'
+      .make_index_URL(
+        array(
+          'tags' => array(
+            array(
+              'id' => $row['id'],
+              'url_name' => $row['url_name'],
+              ),
+            )
+          )
+        )
+      .'">'.$row['name'].'</a>'
+      );
+  }
+
+  $infos['INFO_TAGS'] = implode(', ', $tags);
 }
 else
 {
-  $infos['INFO_KEYWORDS'] = l10n('N/A');
+  $infos['INFO_TAGS'] = l10n('N/A');
 }
 
Index: trunk/search.php
===================================================================
--- trunk/search.php	(revision 1118)
+++ trunk/search.php	(revision 1119)
@@ -66,4 +66,12 @@
   }
 
+  if (isset($_POST['tags']))
+  {
+    $search['fields']['tags'] = array(
+      'words' => $_POST['tags'],
+      'mode'  => $_POST['tag_mode'],
+      );
+  }
+  
   if ($_POST['search_author'])
   {
@@ -201,4 +209,14 @@
   'U_HELP' => PHPWG_ROOT_PATH.'/popuphelp.php?page=search',
   'U_HOME' => make_index_url(),
+
+  'TAG_SELECTION' => get_html_tag_selection(
+    get_available_tags(
+      isset($user['forbidden_categories'])
+      ? explode(',', $user['forbidden_categories'])
+      : null
+      ),
+    'tags',
+    isset($_POST['tags']) ? $_POST['tags'] : array()
+    ),
   )
 );
Index: trunk/search_rules.php
===================================================================
--- trunk/search_rules.php	(revision 1118)
+++ trunk/search_rules.php	(revision 1119)
@@ -84,4 +84,32 @@
 }
 
+if (isset($search['fields']['tags']))
+{
+  $template->assign_block_vars(
+    'tags',
+    array(
+      'LIST_INTRO' => ($search['fields']['tags']['mode'] == 'AND')
+        ? l10n('All tags must match')
+        : l10n('At least one tag must match')
+      )
+    );
+
+  $query = '
+SELECT name
+  FROM '.TAGS_TABLE.'
+  WHERE id IN ('.implode(',', $search['fields']['tags']['words']).')
+;';
+  $result = pwg_query($query);
+  while ($row = mysql_fetch_array($result))
+  {
+    $template->assign_block_vars(
+      'tags.tag',
+      array(
+        'NAME' => $row['name'],
+        )
+      );
+  }
+}
+
 if (isset($search['fields']['author']))
 {
Index: trunk/tags.php
===================================================================
--- trunk/tags.php	(revision 1119)
+++ trunk/tags.php	(revision 1119)
@@ -0,0 +1,120 @@
+<?php
+// +-----------------------------------------------------------------------+
+// | PhpWebGallery - a PHP based picture gallery                           |
+// | Copyright (C) 2002-2003 Pierrick LE GALL - pierrick@phpwebgallery.net |
+// | Copyright (C) 2003-2005 PhpWebGallery Team - http://phpwebgallery.net |
+// +-----------------------------------------------------------------------+
+// | branch        : BSF (Best So Far)
+// | file          : $RCSfile$
+// | last update   : $Date: 2006-03-22 02:01:47 +0100 (mer, 22 mar 2006) $
+// | last modifier : $Author: rvelices $
+// | revision      : $Revision: 1092 $
+// +-----------------------------------------------------------------------+
+// | This program is free software; you can redistribute it and/or modify  |
+// | it under the terms of the GNU General Public License as published by  |
+// | the Free Software Foundation                                          |
+// |                                                                       |
+// | This program is distributed in the hope that it will be useful, but   |
+// | WITHOUT ANY WARRANTY; without even the implied warranty of            |
+// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU      |
+// | General Public License for more details.                              |
+// |                                                                       |
+// | You should have received a copy of the GNU General Public License     |
+// | along with this program; if not, write to the Free Software           |
+// | Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, |
+// | USA.                                                                  |
+// +-----------------------------------------------------------------------+
+
+// +-----------------------------------------------------------------------+
+// |                             functions                                 |
+// +-----------------------------------------------------------------------+
+
+function counter_compare($a, $b)
+{
+  if ($a['counter'] == $b['counter'])
+  {
+    return tag_id_compare($a, $b);
+  }
+
+  return ($a['counter'] < $b['counter']) ? -1 : 1;
+}
+
+function tag_id_compare($a, $b)
+{
+  return ($a['tag_id'] < $b['tag_id']) ? -1 : 1;
+}
+
+// +-----------------------------------------------------------------------+
+// |                           initialization                              |
+// +-----------------------------------------------------------------------+
+
+define('PHPWG_ROOT_PATH','./');
+include_once(PHPWG_ROOT_PATH.'include/common.inc.php');
+
+check_status(ACCESS_GUEST);
+
+// +-----------------------------------------------------------------------+
+// |                       page header and options                         |
+// +-----------------------------------------------------------------------+
+
+$title= l10n('Tags');
+$page['body_id'] = 'theTagsPage';
+include(PHPWG_ROOT_PATH.'include/page_header.php');
+
+$template->set_filenames(array('tags'=>'tags.tpl'));
+$template->assign_vars(
+  array(
+    'U_HOME' => make_index_url(),
+    )
+  );
+
+// +-----------------------------------------------------------------------+
+// |                        tag cloud construction                         |
+// +-----------------------------------------------------------------------+
+
+// find all tags available for the current user
+$tags = get_available_tags(explode(',', $user['forbidden_categories']));
+
+// we want only the first most represented tags, so we sort them by counter
+// and take the first tags
+usort($tags, 'counter_compare');
+$tags = array_slice($tags, 0, $conf['full_tag_cloud_items_number']);
+
+// depending on its counter and the other tags counter, each tag has a level
+$tags = add_level_to_tags($tags);
+
+// we want tags diplayed in alphabetic order
+usort($tags, 'name_compare');
+
+// display sorted tags
+foreach ($tags as $tag)
+{
+  $template->assign_block_vars(
+    'tag',
+    array(
+      'URL' => make_index_url(
+        array(
+          'tags' => array(
+            array(
+              'id' => $tag['tag_id'],
+              'url_name' => $tag['url_name'],
+              ),
+            ),
+          )
+        ),
+      
+      'NAME' => $tag['name'],
+      'TITLE' => $tag['counter'],
+      'CLASS' => 'tagLevel'.$tag['level'],
+      )
+    );
+}
+
+// +-----------------------------------------------------------------------+
+// |                           html code display                           |
+// +-----------------------------------------------------------------------+
+
+$template->assign_block_vars('title',array());
+$template->parse('tags');
+include(PHPWG_ROOT_PATH.'include/page_tail.php');
+?>
